If Then Comparisons Flashcards
-eq
equal to (for numbers)
[[ STRING == STRING ]]
equal to (for strings)
-ne
not equal to (for numbers)
[[ STRING != STRING ]]
not equal to (for strings)
-lt
less than (for numbers)
-le
less than or equal to (for numbers)
-gt
greater than (for numbers)
-ge
greater then or equal to (for numbers)
Write an
if statement
include the additional syntax options.
if commands; then commands [elif commands; then commands...] [else commands] fi
Special variables:
$?
Exit status of
last task:
0-255
Special variables:
$!
PID of last background task
Special variables:
$$
PID of shell
Special variables:
$0
Filename of the shell script
Special variables:
$_
Last argument of the previous command
Special variables:
${PIPESTATUS[n]}
return value of
piped commands
(array)
Exit status 0
0 indicates success
Exit status 1
Any exit status other than 0 means failure
[[ -z STRING ]]
empty string, true
[[ -n STRING ]]
not empty string, true
[[ STRING =~ REGEX ]]
Compares String against a Regexp (for strings)
Example:
LINE=”Spaces Present”
NOLINE=”SpacesNotPresent”
if [[ “${NOLINE}” =~ [[:space:]] ]]; then
echo “true for ${NOLINE}”
#echo “Line Number: ${LINENO}”
else
echo “false for ${NOLINE}”
fi
This will print for $LINE but false for $NOLINE
(( NUM < NUM2 ))
Evaluating numerical conditions, specifically NUM2 is greater than NUM, then TRUE
What is clobbering in bash shell?
The process of overwriting existing data [files].
What is noclobber in bash shell?
A setting that will make the shell complain if a redirect is trying to overwrite an existing file.
How do you enable noclobber?
$ set -o noclobber
to check the setting:
$ set -o | grep clobber
How do you disable noclobber?
$ set +o noclobber
[[ -o noclobber ]]
If OPTIONNAME is enabled. Example is noclobber.
[[ ! EXPR ]]
Not
[[ X && Y ]]
And
[[ X || Y ]]
Or
Bash Options:
$ set -o noclobber
Avoid overwriting files (echo “hi” > foo)
Bash Options:
$ set -o errexit
Used to exit upon error, avoiding cascading errors
Bash Options:
$ set -o pipefail
Unveils hidden failures
Bash Options:
$ set -o nounset
Exposes unset variables